
.. DO NOT EDIT.
.. THIS FILE WAS AUTOMATICALLY GENERATED BY SPHINX-GALLERY.
.. TO MAKE CHANGES, EDIT THE SOURCE PYTHON FILE:
.. "_as_gen/run_aabb_interesect.py"
.. LINE NUMBERS ARE GIVEN BELOW.

.. only:: html

    .. note::
        :class: sphx-glr-download-link-note

        :ref:`Go to the end <sphx_glr_download__as_gen_run_aabb_interesect.py>`
        to download the full example code.

.. rst-class:: sphx-glr-example-title

.. _sphx_glr__as_gen_run_aabb_interesect.py:


Testing AABB intersection routine
=================================

This example shows how to use AABB intersection and plot it in matplotlib

.. GENERATED FROM PYTHON SOURCE LINES 9-15

.. code-block:: Python
   :lineno-start: 10


    import matplotlib.pyplot as plt
    from mpl_toolkits.mplot3d.art3d import Line3DCollection, Poly3DCollection

    import shamrock








.. GENERATED FROM PYTHON SOURCE LINES 16-78

.. code-block:: Python
   :lineno-start: 18



    def draw_aabb(ax, aabb, color, alpha):
        """
        Draw a 3D AABB in matplotlib

        Parameters
        ----------
        ax : matplotlib.Axes3D
            The axis to draw the AABB on
        aabb : shamrock.math.AABB_f64_3
            The AABB to draw
        color : str
            The color of the AABB
        alpha : float
            The transparency of the AABB
        """
        xmin, ymin, zmin = aabb.lower()
        xmax, ymax, zmax = aabb.upper()

        points = [
            aabb.lower(),
            (aabb.lower()[0], aabb.lower()[1], aabb.upper()[2]),
            (aabb.lower()[0], aabb.upper()[1], aabb.lower()[2]),
            (aabb.lower()[0], aabb.upper()[1], aabb.upper()[2]),
            (aabb.upper()[0], aabb.lower()[1], aabb.lower()[2]),
            (aabb.upper()[0], aabb.lower()[1], aabb.upper()[2]),
            (aabb.upper()[0], aabb.upper()[1], aabb.lower()[2]),
            aabb.upper(),
        ]

        faces = [
            [points[0], points[1], points[3], points[2]],
            [points[4], points[5], points[7], points[6]],
            [points[0], points[1], points[5], points[4]],
            [points[2], points[3], points[7], points[6]],
            [points[0], points[2], points[6], points[4]],
            [points[1], points[3], points[7], points[5]],
        ]

        edges = [
            [points[0], points[1]],
            [points[0], points[2]],
            [points[0], points[4]],
            [points[1], points[3]],
            [points[1], points[5]],
            [points[2], points[3]],
            [points[2], points[6]],
            [points[3], points[7]],
            [points[4], points[5]],
            [points[4], points[6]],
            [points[5], points[7]],
            [points[6], points[7]],
        ]

        collection = Poly3DCollection(faces, alpha=alpha, color=color)
        ax.add_collection3d(collection)

        edge_collection = Line3DCollection(edges, color="k", alpha=alpha)
        ax.add_collection3d(edge_collection)









.. GENERATED FROM PYTHON SOURCE LINES 79-99

.. code-block:: Python
   :lineno-start: 80


    fig = plt.figure()
    ax = fig.add_subplot(111, projection="3d")

    aabb1 = shamrock.math.AABB_f64_3((-1.0, -1.0, -1.0), (2.0, 2.0, 2.0))
    aabb2 = shamrock.math.AABB_f64_3((-2.0, -2.0, -2.0), (1.0, 1.0, 1.0))

    draw_aabb(ax, aabb1, "b", 0.1)
    draw_aabb(ax, aabb2, "r", 0.1)
    draw_aabb(ax, aabb1.get_intersect(aabb2), "g", 0.5)

    ax.set_xlabel("X")
    ax.set_ylabel("Y")
    ax.set_zlabel("Z")

    ax.set_xlim(-2, 2)
    ax.set_ylim(-2, 2)
    ax.set_zlim(-2, 2)

    plt.show()



.. image-sg:: /_as_gen/images/sphx_glr_run_aabb_interesect_001.png
   :alt: run aabb interesect
   :srcset: /_as_gen/images/sphx_glr_run_aabb_interesect_001.png
   :class: sphx-glr-single-img






.. rst-class:: sphx-glr-timing

   **Total running time of the script:** (0 minutes 0.340 seconds)

**Estimated memory usage:**  71 MB


.. _sphx_glr_download__as_gen_run_aabb_interesect.py:

.. only:: html

  .. container:: sphx-glr-footer sphx-glr-footer-example

    .. container:: sphx-glr-download sphx-glr-download-jupyter

      :download:`Download Jupyter notebook: run_aabb_interesect.ipynb <run_aabb_interesect.ipynb>`

    .. container:: sphx-glr-download sphx-glr-download-python

      :download:`Download Python source code: run_aabb_interesect.py <run_aabb_interesect.py>`

    .. container:: sphx-glr-download sphx-glr-download-zip

      :download:`Download zipped: run_aabb_interesect.zip <run_aabb_interesect.zip>`


.. only:: html

 .. rst-class:: sphx-glr-signature

    `Gallery generated by Sphinx-Gallery <https://sphinx-gallery.github.io>`_
